#include <bits/stdc++.h>

using namespace std;

int main()
{
    int n;
    int k[1000000];
    bool pojavio[10]={};
    int pojavioprvi[10]={};
    int pojavioposlednji[10]={};
    int p1,p2;

    cin >> n;
    for(int i=1;i<=n;i++)
    {
        cin >> k[i];
        if (pojavio[k[i]]==false)
        {
            pojavio [k[i]]=true;
            pojavioprvi[k[i]]=i;
            pojavioposlednji[k[i]]=i;
        }
        pojavioposlednji[k[i]]=i;
    }
   
    sort(pojavioprvi,pojavioprvi+10);
    
    
    for(int i=0;i<=9;i++)
    {
        if(pojavioprvi[i]==0)
        {
        continue;
        
        }
        
         int maxi=0;
         for(int j=0;j<=9;j++)
        {
           if(k[pojavioposlednji[j]]>maxi && pojavioposlednji[j]!=0 && pojavioposlednji[j]>pojavioprvi[i])
           {
               maxi=k[pojavioposlednji[j]];
               p2=pojavioposlednji[j];
           }
        }
        
        if(k[pojavioprvi[i]]<maxi &&  pojavioprvi[i]<p2)
        {
            p1=pojavioprvi[i];

            k[p2]=k[p1];
            k[p1]=maxi;
            for(int i=1;i<=n;i++)
            {
                cout << k[i] << ' ';
            }
            return 0;
        }
    }
    
    for(int i=0;i<=9;i++)
    {
        for(int j=0;j<=9;j++)
        {
            if(k[pojavioposlednji[j]]==k[pojavioprvi[i]] && pojavioprvi[i]!=pojavioposlednji[j])
            {
                for(int i=1;i<=n;i++)
            {
                cout << k[i] << ' ';
            }
            return 0;
            }
        }
    }
    int s=k[n];
    k[n]=k[n-1];
    k[n-1]=s;
     for(int i=1;i<=n;i++)
            {
                cout << k[i] << ' ';
            }

    return 0;
}